''' For each system the following must be defined:
J --
JName --
SpinArray --

If 'mode' is 1, for each system the following also needs to be defined:
JValue --
JValueError  --
 
 
NOTE: You also need to point to the right function in getData() at the end of this file, which takes the 
command-line argument regarding system to use
 
'''


def getAlpha():
	# The alpha Fe(III)13 Baker-Figgis-Keggin isomer 
	JName=['0','J2','J1a','J1b','0','0','0','0','0','0','0','0','0']
	#Spin coupling matrix
	J=[[0, 2, 2, 0, 0, 3, 3, 0, 0, 0, 0, 0, 1], \
	   [2, 0, 2, 0, 0, 0, 0, 0, 3, 3, 0, 0, 1], \
	   [2, 2, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3, 1], \
	   [0, 0, 3, 0, 2, 2, 0, 0, 0, 0, 0, 3, 1], \
	   [0, 0, 0, 2, 0, 2, 0, 3, 0, 0, 3, 0, 1], \
	   [3, 0, 0, 2, 2, 0, 3, 0, 0, 0, 0, 0, 1], \
	   [3, 0, 0, 0, 0, 3, 0, 2, 2, 0, 0, 0, 1], \
	   [0, 0, 0, 0, 3, 0, 2, 0, 2, 0, 3, 0, 1], \
	   [0, 3, 0, 0, 0, 0, 2, 2, 0, 3, 0, 0, 1], \
	   [0, 3, 0, 0, 0, 0, 0, 0, 3, 0, 2, 2, 1], \
	   [0, 0, 0, 0, 3, 0, 0, 3, 0, 2, 0, 2, 1], \
	   [0, 0, 3, 3, 0, 0, 0, 0, 0, 2, 2, 0, 1], \
	   [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0]]

	#Spins of the centres in the coupling matrix
	SpinArray =[5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0]

# 	Fitted data:
# 	Only used when mode is 1. Not needed for mode 0.
	#JValue=[0,-35.2112,1.35205,-22.5191,0,0,0,0,0,0,0,0] # M06/svp+tzvp w smd
	#JValueError=[0,2.423,1.574,1.672,0,0,0,0,0,0,0,0] # M06/svp+tzvp w smd
	#JValue=[0,-107.911,-60.0534,-72.9388,0,0,0,0,0,0,0,0] #BP86/svp+tzvp w pcm
	#JValueError=[0,42.13,27.36,29.07,0,0,0,0,0,0,0,0] # BP86/svp+tzvp w pcm
	#JValue=[0,-28.2093,-2.06856,-26.5474,0,0,0,0,0,0,0,0] #PBE0/svp+tzvp w pcm
	#JValueError=[0,1.459,0.9474,1.007,0,0,0,0,0,0,0,0] # PEB0/svp+tzvp w pcm
	#JValue=[0,-31.8966,-6.65384,-32.874,0,0,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm  -- only BS set
	#JValueError=[0,1.667,1.082,1.150,0,0,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm -- only BS set
	JValue=[0,-32.0749,-6.65149,-32.3395,0,0,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm  X set
	JValueError=[0,0.4535,0.4495,0.4761,0,0,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm X set

	return J, JName, SpinArray, JValue, JValueError

def getBeta():
	# The beta Fe(III)13 Baker-Figgis-Keggin isomer 
	# beta 2=j1a, 3=j1b, 1=j2, 4=j1c
	JName=['0','J2','J1a','J1b','0','0','0','0','0','0','0','0','0']
	J=[[0, 2, 2, 3, 0, 3, 0, 0, 0, 0, 0, 0, 1], \
	   [2, 0, 2, 0, 0, 0, 3, 0, 3, 0, 0, 0, 1], \
	   [2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 1], \
	   [3, 0, 0, 0, 2, 2, 0, 0, 0, 0, 0, 3, 1], \
	   [0, 0, 0, 2, 0, 2, 0, 3, 0, 0, 3, 0, 1], \
	   [3, 0, 0, 2, 2, 0, 3, 0, 0, 0, 0, 0, 1], \
	   [0, 3, 0, 0, 0, 3, 0, 2, 2, 0, 0, 0, 1], \
	   [0, 0, 0, 0, 3, 0, 2, 0, 2, 0, 3, 0, 1], \
	   [0, 3, 0, 0, 0, 0, 2, 2, 0, 0, 3, 0, 1], \
	   [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 1], \
	   [0, 0, 3, 0, 3, 0, 0, 3, 3, 2, 0, 2, 1], \
	   [0, 0, 3, 3, 0, 0, 0, 0, 0, 2, 2, 0, 1], \
	   [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0]]

	SpinArray =[5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0] 
	
	#JValue=[0,-32.9785,1.83288,-29.7841,0,0,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm -- only BS set
	#JValueError=[0,1.566,2.684,2.274,0,0,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm -- only BS set
	JValue=[0,-29.9785,-8.62093,-26.9596,0,0,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm X set
	JValueError=[0,1.566,3.573,5.2390,0,0,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm X set
	return J, JName, SpinArray, JValue, JValueError
	
def getGamma():
	# The gamma Fe(III)13 Baker-Figgis-Keggin isomer 	
	
	JName=['0','J2','J1a','J1b','0','J1d','0','0','0','0','0','0','0']
	J=[[0, 2, 2, 0, 0, 5, 0, 0, 0, 0, 0, 0, 1], \
	   [2, 0, 2, 0, 0, 0, 3, 0, 3, 0, 0, 0, 1], \
	   [2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 1], \
	   [0, 0, 0, 0, 2, 2, 0, 0, 0, 3, 0, 3, 1], \
	   [0, 0, 0, 2, 0, 2, 3, 3, 0, 0, 0, 0, 1], \
	   [5, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 1], \
	   [0, 3, 0, 0, 3, 0, 0, 2, 2, 0, 0, 0, 1], \
	   [0, 0, 0, 0, 3, 0, 2, 0, 2, 3, 0, 0, 1], \
	   [0, 3, 0, 0, 0, 0, 2, 2, 0, 0, 3, 0, 1], \
	   [0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 2, 2, 1], \
	   [0, 0, 3, 0, 0, 0, 0, 0, 3, 2, 0, 2, 1], \
	   [0, 0, 3, 3, 0, 0, 0, 0, 0, 2, 2, 0, 1], \
	   [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0]]

	SpinArray =[5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0] 
	#JValue=[0,-31.1054,-6.77049,-29.046,0,-24.4109,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm
	#JValueError=[0,0.2046,0.4864,0.2716,0,1.717,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm
	JValue=[0,-31.6417,-6.27393,-29.4497,0,-23.3231,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm X set
	JValueError=[0,0.4647,1.026,0.9103,0,4.839,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm X set
	return Jgamma, JNameGamma, SpinArray, JValueGamma, JValueGammaError

def getDelta():
	JName=['0','J2','J1a','J1b','0','J1d','0','0','0','0','0','0','0']
	
	J=[[0, 2, 2, 0, 0, 5, 0, 0, 0, 0, 0, 0, 1], \
	   [2, 0, 2, 0, 0, 0, 5, 0, 0, 0, 0, 0, 1], \
	   [2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 1], \
	   [0, 0, 0, 0, 2, 2, 0, 0, 0, 3, 0, 3, 1], \
	   [0, 0, 0, 2, 0, 2, 0, 5, 0, 0, 0, 0, 1], \
	   [5, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 1], \
	   [0, 5, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 1], \
	   [0, 0, 0, 0, 5, 0, 2, 0, 2, 0, 0, 0, 1], \
	   [0, 0, 0, 0, 0, 0, 2, 2, 0, 3, 3, 0, 1], \
	   [0, 0, 0, 3, 0, 0, 0, 0, 3, 0, 2, 2, 1], \
	   [0, 0, 3, 0, 0, 0, 0, 0, 3, 2, 0, 2, 1], \
	   [0, 0, 3, 3, 0, 0, 0, 0, 0, 2, 2, 0, 1], \
	   [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0]]
	SpinArray =[5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0] 

	#JValue=[0,-29.806,-5.07834,-30.0776,0,-15.1673,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm
	#JValueError=[0,0.7859,1.42,1.18,0,2.581,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm
	JValue=[0,-29.5641,-4.92424,-29.759,0,-18.8791,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm X set
	JValueError=[0,0.5596,0.7783,0.9269,0,1.995,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm X set

	return J, JName, SpinArray, JValue, JValueError

def getEpsilon():
	JName=['0','J2','J1a','0','0','J1d','0','0','0','0','0','0','0']
	JValue= [0 if x=='0' else 1 for x in JName]
	JValueError= [0 if x=='0' else 1 for x in JName]

	J=[[0, 2, 2, 0, 0, 5, 0, 0, 0, 0, 0, 0, 1], \
	   [2, 0, 2, 0, 0, 0, 5, 0, 0, 0, 0, 0, 1], \
	   [2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 1], \
	   [0, 0, 0, 0, 2, 2, 0, 0, 0, 5, 0, 0, 1], \
	   [0, 0, 0, 2, 0, 2, 0, 5, 0, 0, 0, 0, 1], \
	   [5, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 1], \
	   [0, 5, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 1], \
	   [0, 0, 0, 0, 5, 0, 2, 0, 2, 0, 0, 0, 1], \
	   [0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 5, 0, 1], \
	   [0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 2, 2, 1], \
	   [0, 0, 0, 0, 0, 0, 0, 0, 5, 2, 0, 2, 1], \
	   [0, 0, 5, 0, 0, 0, 0, 0, 0, 2, 2, 0, 1], \
	   [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0]]

	SpinArray =[5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0] 
	#JValue=[0,-28.2502,-3.92415,0,0,-18.7115,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm
	#JValueError=[0,1.13,1.206,0,0,2.474,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm
	JValue=[0,-27.5094,-3.14517,0,0,-19.3922,0,0,0,0,0,0] # b3lyp/svp+tzvp w pcm X set
	JValueError=[0,0.4107,0.5585,0,0,1.115,0,0,0,0,0,0]# b3lyp/svp+tzvp w pcm X set
	return J, JName, SpinArray, JValue, JValueError

def getExample():
	#Example is for testing/development purposes. The atoms are at the corner of a square. Direct neighbours couple via J1a, diagonals couple via J2.
	JName=['0','J2','J1a','J1b','J1c','0','0','0','0','0','0','0','0']
	
	J=[[0,4,3,4], \
	   [4,0,2,1], \
	   [3,2,0,2], \
	   [4,1,2,0]]
	SpinArray =[5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0] 
	#JValue=[0,-28.2502,-3.92415,1,1,0,0,0,0,0,0,0] # For testing
	#JValueError=[0,1.13,1.206,2,2,0,0,0,0,0,0,0]# For testing
	JValue= [0 if x=='0' else 1 for x in JName]
	JValueError= [0 if x=='0' else 1 for x in JName]

	return J, JName, SpinArray, JValue, JValueError
	
def getIs():
	#is -- iron-sulfur cluster -- [Fe6S6Cl6]-. Atom 6 is Fe(II), rest are Fe(III). S bridges. Cl terminal.
	# Czerwinski, INt J. Quant Chem, 1999, 72, 39
	JName=['0','J1','J2','J3','J4','0','0','0','0','0','0','0','0']

	J=[[0,3,4,2,2,1], \
	   [3,0,2,4,2,1], \
	   [4,2,0,3,2,1], \
	   [2,4,3,0,2,1], \
	   [2,2,2,2,0,1], \
	   [1,1,1,1,1,0]] 

	SpinArray =[5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,5.0/2.0,4.0/2.0] 	
	
	#JValue=[0,-28.2502,-3.92415,1,1,0,0,0,0,0,0,0] # For testing
	#JValueError=[0,1.13,1.206,2,2,0,0,0,0,0,0,0]# For testing
	JValue= [0 if x=='0' else 1 for x in JName]
	JValueError= [0 if x=='0' else 1 for x in JName]

	return J, JName, SpinArray, JValue, JValueError
  
def getData(Isomer):
	if Isomer=='a':
		J,JName,SpinArray,JValue,JValueError=getAlpha()
	elif Isomer=='b':
		J,JName,SpinArray,JValue,JValueError=getBeta()
	elif Isomer=='g':
		J,JName,SpinArray,JValue,JValueError=getGamma()
	elif Isomer=='d':
		J,JName,SpinArray,JValue,JValueError=getDelta()
	elif Isomer=='e':
		J,JName,SpinArray,JValue,JValueError=getEpsilon()
	elif Isomer=='example': #For testing/development purposes
		J,JName,SpinArray,JValue,JValueError=getExample()
	elif Isomer=='is': #For testing/development purposes
		J,JName,SpinArray,JValue,JValueError=getIs()
		
	return J,JName,SpinArray,JValue,JValueError
